Legrand / Raritan / Server Technology Xerus™ JSON-RPC API

Loading...
Searching...
No Matches
DsamDevice.idl
1/* SPDX-License-Identifier: BSD-3-Clause */
2/*
3 * Copyright 2022 Raritan Inc. All rights reserved.
4 */
5
6#ifndef __DSAMDEVICE_IDL__
7#define __DSAMDEVICE_IDL__
8
9#include <DsamPort.idl>
10
11module dsam {
12
13 /** DSAM device interface */
14 interface DsamDevice {
15
16 /** Success code */
17 constant int SUCCESS = 0;
18
19 /** Firmware version */
20 structure FirmwareVersion {
21 int major; ///< major version number
22 int minor; ///< minor version number
23 };
24
25 /** DSAm device info */
26 structure Info {
27 int dsamNumber; ///< DSAM number (1-based)
28 string serialNumber; ///< DSAM serial number
29 int portCount; ///< Number of ports on the DSAM
30 int hardwareVersion; ///< Hardware version number
31 FirmwareVersion firmwareVersion; ///< Firmware version
32 };
33
34 /**
35 * Get DSAM device info
36 *
37 * @return DSAM device info
38 */
39 Info getInfo();
40
41 /**
42 * Retrieve the current DSAM ports.
43 *
44 * @return Map with DSAM ports. Index is the port number (1-based).
45 */
46 map<int, DsamPort> getPorts();
47
48 /**
49 * Start firmware update on the DSAM device.
50 *
51 * @return SUCCESS if no error occured
52 */
53 int startFirmwareUpdate();
54 };
55
56}
57
58#endif // __DSAMDEVICE_IDL__
dsam::DsamDevice
DSAM device interface.
Definition DsamDevice.idl:14
dsam::DsamDevice::getPorts
map< int, DsamPort > getPorts()
Retrieve the current DSAM ports.
dsam::DsamDevice::getInfo
Info getInfo()
Get DSAM device info.
dsam::DsamDevice::startFirmwareUpdate
int startFirmwareUpdate()
Start firmware update on the DSAM device.
dsam::DsamDevice::FirmwareVersion
Firmware version.
Definition DsamDevice.idl:20
dsam::DsamDevice::FirmwareVersion::major
int major
major version number
Definition DsamDevice.idl:21
dsam::DsamDevice::FirmwareVersion::minor
int minor
minor version number
Definition DsamDevice.idl:22
dsam::DsamDevice::Info
DSAm device info.
Definition DsamDevice.idl:26
dsam::DsamDevice::Info::firmwareVersion
FirmwareVersion firmwareVersion
Firmware version.
Definition DsamDevice.idl:31
dsam::DsamDevice::Info::serialNumber
string serialNumber
DSAM serial number.
Definition DsamDevice.idl:28
dsam::DsamDevice::Info::portCount
int portCount
Number of ports on the DSAM.
Definition DsamDevice.idl:29
dsam::DsamDevice::Info::hardwareVersion
int hardwareVersion
Hardware version number.
Definition DsamDevice.idl:30
dsam::DsamDevice::Info::dsamNumber
int dsamNumber
DSAM number (1-based)
Definition DsamDevice.idl:27